%global dlrn_nvr oslo.config-8.5.1-17.1.20230622062552.de1dbee
%global dlrn 1
%define upstream_version 8.5.1
%{!?sources_gpg: %{!?dlrn:%global sources_gpg 1} }
%global sources_gpg_sign 0x4c29ff0e437f3351fd82bdf47c5a3bc787dc7035
%global sname oslo.config
%global pypi_name oslo-config
%global with_doc 0
%global repo_bootstrap 1

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:       python-oslo-config
Epoch:      2
Version: 8.5.1
Release: 17.1.20230622062553.de1dbee%{?dist}
Summary:    OpenStack common configuration library

Group:      Development/Languages
License:    ASL 2.0
URL:        https://launchpad.net/%{sname}
Source0: oslo.config-8.5.1-17.1.20230622062552.de1dbee.tar.gz
# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
Source101:        https://tarballs.openstack.org/%{sname}/%{sname}-%{upstream_version}.tar.gz.asc
Source102:        https://releases.openstack.org/_static/%{sources_gpg_sign}.txt
%endif

#
# patches_ignore=DROP-IN-RPM
# patches_base=de1dbeed235d2df7cf1528aef6ad4a70ddf8559f
Patch0001: 0001-add-usr-share-project-dist.conf-to-the-default-confi.patch

BuildArch:  noarch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
BuildRequires:  /usr/bin/gpgv2
BuildRequires:  openstack-macros
%endif

%description
The Oslo project intends to produce a python library containing
infrastructure code shared by OpenStack projects. The APIs provided
by the project should be high quality, stable, consistent and generally
useful.

The oslo-config library is a command line and configuration file
parsing library from the Oslo project.

%package -n python3-%{pypi_name}
Summary:    OpenStack common configuration library
%{?python_provide:%python_provide python3-%{pypi_name}}
Obsoletes: python2-%{pypi_name} < %{version}-%{release}

Requires:   python3-importlib-metadata >= 1.7.0
Requires:   python3-oslo-i18n >= 3.15.3
Requires:   python3-rfc3986 >= 1.2.0
Requires:   python3-pbr
Requires:   python3-requests >= 2.18.0
Requires:   python3-stevedore >= 1.20.0
Requires:   python3-debtcollector >= 1.2.0
Requires:   python3-netaddr >= 0.7.18
Requires:   python3-yaml >= 5.1

BuildRequires: python3-devel
BuildRequires: python3-setuptools
BuildRequires: python3-oslo-i18n
BuildRequires: python3-rfc3986
BuildRequires: python3-pbr
BuildRequires: git-core
# Required for tests
BuildRequires: python3-importlib-metadata
BuildRequires: python3-testscenarios
BuildRequires: python3-stestr
BuildRequires: python3-testtools
BuildRequires: python3-oslotest
BuildRequires: python3-requests-mock
BuildRequires: python3-netaddr
BuildRequires: python3-stevedore
BuildRequires: python3-PyYAML

%if 0%{?repo_bootstrap} == 0
BuildRequires: python3-oslo-log
%endif

%description -n python3-%{pypi_name}
The Oslo project intends to produce a python library containing
infrastructure code shared by OpenStack projects. The APIs provided
by the project should be high quality, stable, consistent and generally
useful.

The oslo-config library is a command line and configuration file
parsing library from the Oslo project.

%if 0%{?with_doc}
%package -n python-%{pypi_name}-doc
Summary:    Documentation for OpenStack common configuration library

BuildRequires: python3-sphinx
BuildRequires: python3-fixtures
BuildRequires: python3-openstackdocstheme
BuildRequires: python3-oslotest >= 1.10.0
BuildRequires: python3-debtcollector
BuildRequires: python3-stevedore
BuildRequires: python3-sphinxcontrib-apidoc

%description -n python-%{pypi_name}-doc
Documentation for the oslo-config library.
%endif

%prep
# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
%{gpgverify}  --keyring=%{SOURCE102} --signature=%{SOURCE101} --data=%{SOURCE0}
%endif
%autosetup -n %{sname}-%{upstream_version} -S git
# Remove shebang from non executable file, it's used by the oslo-config-validator binary.
sed -i '/\/usr\/bin\/env/d' oslo_config/validator.py
# let RPM handle deps
rm -rf {test-,}requirements.txt

# Remove tests requiring sphinx if sphinx is not available
%if 0%{?with_doc} == 0
rm oslo_config/tests/test_sphinxext.py
rm oslo_config/tests/test_sphinxconfiggen.py
%endif

%build
%{py3_build}

%if 0%{?with_doc}
export PYTHONPATH=.
sphinx-build-3 -b html doc/source doc/build/html
# remove the sphinx-build-3 leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%install
%{py3_install}
pushd %{buildroot}/%{_bindir}
for i in generator validator
do
ln -s oslo-config-$i oslo-config-$i-3
done
popd

%check
%if 0%{?repo_bootstrap} == 0
# Skip test_generator_raises_error until https://review.opendev.org/#/c/742589/ is in tag release
PYTHON=python3 stestr-3 run --black-regex test_generator_raises_error
%endif

%files -n python3-%{pypi_name}
%doc README.rst
%license LICENSE
%{_bindir}/oslo-config-generator
%{_bindir}/oslo-config-generator-3
%{_bindir}/oslo-config-validator
%{_bindir}/oslo-config-validator-3
%{python3_sitelib}/oslo_config
%{python3_sitelib}/*.egg-info

%if 0%{?with_doc}
%files -n python-%{pypi_name}-doc
%doc doc/build/html
%license LICENSE
%endif

%changelog
* Thu Jun 22 2023 OSP Prod Chain <dev-null@redhat.com> 2:8.5.1-17.1.20230622062552.de1dbee
- Update patches

* Tue Jan 24 2023 OSP Prod Chain <dev-null@redhat.com> 2:8.5.1-1.20230124123758.de1dbee
- Update patches

* Wed Jul 27 2022 OSP Prod Chain <dev-null@redhat.com> 2:8.5.1-1.20220727221816.de1dbee
- Update patches 

* Tue Jul 12 2022 OSP Prod Chain <dev-null@redhat.com> 2:8.5.1-0.20220712105225.de1dbee
- Update patches

* Wed Sep 08 2021 OSP Prod Chain <dev-null@redhat.com> 2:8.5.1-0.20210908081818.de1dbee
- Update patches
- config-generator yaml format doesn't work with i18n fields
- Add the version parameter.
- Adding the missing HostDomain config option
- Update TOX_CONSTRAINTS_FILE for stable/wallaby
- Update .gitreview for stable/wallaby
- Move flake8 as a pre-commit local target.

* Thu May 27 2021 OSP Prod Chain <dev-null@redhat.com> 2:8.5.0-0.20210527172837.cfa2564
- Update patches

* Wed Mar 24 2021 OSP Prod Chain <dev-null@redhat.com> 2:8.5.0-1
- Update patches

* Thu Mar 18 2021 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Sat Mar 13 2021 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Fri Mar 05 2021 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Bump minimum version for PyYAML to 5.1
- remove lower-constraints.txt
- inherit from object is not required for py3
- Move zuul config file to root folder
- Dropping lower constraints testing
- Remove Babel from lower-constraints.txt

* Wed Dec 16 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Mon Dec 14 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Mon Dec 14 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Sun Nov 22 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Add a new type HostDomain.
- sphinxext: Add 'merge_domaindata'
- Update TOX_CONSTRAINTS_FILE for stable/victoria
- Update .gitreview for stable/victoria

* Fri Nov 13 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Wed Oct 21 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Fri Sep 18 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Bump bandit version

* Wed Jul 29 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Fix unit tests to work with stevedore > 2.0.1

* Mon Jul 27 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Mon Jul 27 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Fri Jul 24 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- drop use of pkg_resources
- Align contributing doc with oslo's policy

* Fri Jul 24 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Tue Jun 30 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Update lower-constraints versions
- Fix pygments style
- generator: Handle 'cfg.Opt'-type options

* Wed Jun 03 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Add py38 package metadata
- Raise hacking minimum to 3.0.1
- Remove the unused coding style modules
- Cap flake8 to be < 3.8.0
- Remove six from lower-constraints.txt
- docs: Mention other ways of escaping '$'
- Resolve UnboundLocalError
- Add release notes links to doc index
- Mark sphinx extensions thread safe
- Add Python3 victoria unit tests
- Update master for stable/ussuri
- Remove redundant class docstring info
- Use unittest.mock instead of third party mock

* Thu Apr 16 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Wed Apr 15 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Thu Apr 09 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- mypy: Add boilerplate configuration
- Switch to hacking 2.x
- Remove six
- Use stevedore to list the source drivers in documentation

* Thu Apr 09 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Thu Mar 19 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Thu Mar 05 2020 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Update the minversion parameter.
- trivial: Cleanup tox.ini
- remove outdated header
- Remove universal wheel configuration
- reword releasenote for py27 support dropping
- [ussuri][goal] Drop python 2.7 support and testing
- tox: Trivial cleanup
- Remove ConfigFilter
- Ensure option groups don't change during logging
- Switch to Ussuri jobs
- update source link in readme
- Support hyphens in positional argument names
- Assume positional arguments are required
- Refactor unit tests for CLI usage

* Tue Nov 26 2019 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches
- Stop configuring install_command in tox.
- fix: fix float opt min and max value format errror
- tox: Keeping going with docs
- Merge "Update master for stable/train"
- Update the constraints url
- Update master for stable/train

* Wed Nov 13 2019 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches

* Wed Oct 02 2019 OSP Prod Chain <dev-null@redhat.com> 2:XXX-XXX
- Update patches


